Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/proc/thread.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -225,33 +225,34 @@
 
 extern void thread_init(void);
-extern thread_t *thread_create(void (*)(void *), void *, task_t *, int, char *,
-    bool);
-extern void thread_attach(thread_t *, task_t *);
-extern void thread_ready(thread_t *);
+extern thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
+    int flags, char *name, bool uncounted);
+extern void thread_attach(thread_t *t, task_t *task);
+extern void thread_ready(thread_t *t);
 extern void thread_exit(void) __attribute__((noreturn));
 
 #ifndef thread_create_arch
-extern void thread_create_arch(thread_t *);
+extern void thread_create_arch(thread_t *t);
 #endif
 #ifndef thr_constructor_arch
-extern void thr_constructor_arch(thread_t *);
+extern void thr_constructor_arch(thread_t *t);
 #endif
 #ifndef thr_destructor_arch
-extern void thr_destructor_arch(thread_t *);
-#endif
-
-extern void thread_sleep(uint32_t);
-extern void thread_usleep(uint32_t);
+extern void thr_destructor_arch(thread_t *t);
+#endif
+
+extern void thread_sleep(uint32_t sec);
+extern void thread_usleep(uint32_t usec);
 
 #define thread_join(t) \
 	thread_join_timeout((t), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-extern int thread_join_timeout(thread_t *, uint32_t, int);
-extern void thread_detach(thread_t *);
-
-extern void thread_register_call_me(void (*)(void *), void *);
+extern int thread_join_timeout(thread_t *t, uint32_t usec, int flags);
+extern void thread_detach(thread_t *t);
+
+extern void thread_register_call_me(void (* call_me)(void *),
+    void *call_me_with);
 extern void thread_print_list(void);
-extern void thread_destroy(thread_t *);
+extern void thread_destroy(thread_t *t);
 extern void thread_update_accounting(void);
-extern bool thread_exists(thread_t *);
+extern bool thread_exists(thread_t *t);
 
 /** Fpu context slab cache. */
@@ -259,9 +260,8 @@
 
 /* Thread syscall prototypes. */
-extern unative_t sys_thread_create(uspace_arg_t *, char *, size_t,
-    thread_id_t *);
-extern unative_t sys_thread_exit(int);
-extern unative_t sys_thread_get_id(thread_id_t *);
-extern unative_t sys_thread_usleep(uint32_t);
+extern unative_t sys_thread_create(uspace_arg_t *uspace_uarg,
+    char *uspace_name, size_t name_len, thread_id_t *uspace_thread_id);
+extern unative_t sys_thread_exit(int uspace_status);
+extern unative_t sys_thread_get_id(thread_id_t *uspace_thread_id);
 
 #endif
Index: kernel/generic/include/string.h
===================================================================
--- kernel/generic/include/string.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/string.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -87,5 +87,5 @@
 extern void str_cpy(char *dest, size_t size, const char *src);
 extern void str_ncpy(char *dest, size_t size, const char *src, size_t n);
-extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
+extern void wstr_nstr(char *dst, const wchar_t *src, size_t size);
 
 extern char *str_chr(const char *str, wchar_t ch);
Index: kernel/generic/include/synch/futex.h
===================================================================
--- kernel/generic/include/synch/futex.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/synch/futex.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -38,4 +38,6 @@
 #include <arch/types.h>
 #include <synch/waitq.h>
+#include <genarch/mm/page_ht.h>
+#include <genarch/mm/page_pt.h>
 
 /** Kernel-side futex structure. */
@@ -52,6 +54,7 @@
 
 extern void futex_init(void);
-extern unative_t sys_futex_sleep(uintptr_t);
-extern unative_t sys_futex_wakeup(uintptr_t);
+extern unative_t sys_futex_sleep_timeout(uintptr_t uaddr, uint32_t usec,
+    int flags);
+extern unative_t sys_futex_wakeup(uintptr_t uaddr);
 
 extern void futex_cleanup(void);
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/syscall/syscall.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -43,5 +43,4 @@
 	SYS_THREAD_EXIT,
 	SYS_THREAD_GET_ID,
-	SYS_THREAD_USLEEP,
 	
 	SYS_TASK_GET_ID,
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/console/console.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -319,15 +319,15 @@
 	
 	if (size > PAGE_SIZE)
-		return (unative_t) ELIMIT;
+		return ELIMIT;
 	
 	if (size > 0) {
 		data = (char *) malloc(size + 1, 0);
 		if (!data)
-			return (unative_t) ENOMEM;
+			return ENOMEM;
 		
 		rc = copy_from_uspace(data, buf, size);
 		if (rc) {
 			free(data);
-			return (unative_t) rc;
+			return rc;
 		}
 		data[size] = 0;
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/console/kconsole.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -289,5 +289,5 @@
 			
 			char tmp[STR_BOUNDS(MAX_CMDLINE)];
-			wstr_to_str(tmp, position - beg + 1, current + beg);
+			wstr_nstr(tmp, current + beg, position - beg + 1);
 			
 			int found;
@@ -665,5 +665,5 @@
 		
 		char cmdline[STR_BOUNDS(MAX_CMDLINE)];
-		wstr_to_str(cmdline, STR_BOUNDS(MAX_CMDLINE), tmp);
+		wstr_nstr(cmdline, tmp, STR_BOUNDS(MAX_CMDLINE));
 		
 		if ((!kcon) && (len == 4) && (str_lcmp(cmdline, "exit", 4) == 0))
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/ipc/ipc.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -62,5 +62,4 @@
 
 static slab_cache_t *ipc_call_slab;
-static slab_cache_t *ipc_answerbox_slab;
 
 /** Initialize a call structure.
@@ -97,4 +96,15 @@
 }
 
+/** Initialize a statically allocated call structure.
+ *
+ * @param call		Statically allocated kernel call structure to be
+ *			initialized.
+ */
+void ipc_call_static_init(call_t *call)
+{
+	_ipc_call_init(call);
+	call->flags |= IPC_CALL_STATIC_ALLOC;
+}
+
 /** Deallocate a call structure.
  *
@@ -103,4 +113,5 @@
 void ipc_call_free(call_t *call)
 {
+	ASSERT(!(call->flags & IPC_CALL_STATIC_ALLOC));
 	/* Check to see if we have data in the IPC_M_DATA_SEND buffer. */
 	if (call->buffer)
@@ -119,5 +130,4 @@
 	spinlock_initialize(&box->irq_lock, "ipc_box_irqlock");
 	waitq_initialize(&box->wq);
-	link_initialize(&box->sync_box_link);
 	list_initialize(&box->connected_phones);
 	list_initialize(&box->calls);
@@ -169,41 +179,15 @@
 int ipc_call_sync(phone_t *phone, call_t *request)
 {
-	answerbox_t *sync_box; 
-	ipl_t ipl;
-
-	sync_box = slab_alloc(ipc_answerbox_slab, 0);
-	ipc_answerbox_init(sync_box, TASK);
-
-	/*
-	 * Put the answerbox on the TASK's list of synchronous answerboxes so
-	 * that it can be cleaned up if the call is interrupted.
-	 */
-	ipl = interrupts_disable();
-	spinlock_lock(&TASK->lock);
-	list_append(&sync_box->sync_box_link, &TASK->sync_box_head);
-	spinlock_unlock(&TASK->lock);
-	interrupts_restore(ipl);
+	answerbox_t sync_box; 
+
+	ipc_answerbox_init(&sync_box, TASK);
 
 	/* We will receive data in a special box. */
-	request->callerbox = sync_box;
+	request->callerbox = &sync_box;
 
 	ipc_call(phone, request);
-	if (!ipc_wait_for_call(sync_box, SYNCH_NO_TIMEOUT,
-	    SYNCH_FLAGS_INTERRUPTIBLE)) {
-	    	/* The answerbox and the call will be freed by ipc_cleanup(). */
+	if (!ipc_wait_for_call(&sync_box, SYNCH_NO_TIMEOUT,
+	    SYNCH_FLAGS_INTERRUPTIBLE))
 		return EINTR;
-	}
-
-	/*
-	 * The answer arrived without interruption so we can remove the
-	 * answerbox from the TASK's list of synchronous answerboxes.
-	 */
-	(void) interrupts_disable();
-	spinlock_lock(&TASK->lock);
-	list_remove(&sync_box->sync_box_link);
-	spinlock_unlock(&TASK->lock);
-	interrupts_restore(ipl);
-
-	slab_free(ipc_answerbox_slab, sync_box);
 	return EOK;
 }
@@ -536,5 +520,4 @@
 	int i;
 	call_t *call;
-	ipl_t ipl;
 
 	/* Disconnect all our phones ('ipc_phone_hangup') */
@@ -562,19 +545,5 @@
 	spinlock_unlock(&TASK->answerbox.lock);
 	
-	/* Wait for all answers to interrupted synchronous calls to arrive */
-	ipl = interrupts_disable();
-	while (!list_empty(&TASK->sync_box_head)) {
-		answerbox_t *box = list_get_instance(TASK->sync_box_head.next,
-		    answerbox_t, sync_box_link);
-
-		list_remove(&box->sync_box_link);
-		call = ipc_wait_for_call(box, SYNCH_NO_TIMEOUT,
-		    SYNCH_FLAGS_NONE);
-		ipc_call_free(call);
-		slab_free(ipc_answerbox_slab, box);
-	}
-	interrupts_restore(ipl);
-
-	/* Wait for all answers to asynchronous calls to arrive */
+	/* Wait for all async answers to arrive */
 	while (1) {
 		/* Go through all phones, until all are FREE... */
@@ -583,8 +552,6 @@
 		for (i = 0; i < IPC_MAX_PHONES; i++) {
 			if (TASK->phones[i].state == IPC_PHONE_HUNGUP &&
-			    atomic_get(&TASK->phones[i].active_calls) == 0) {
+			    atomic_get(&TASK->phones[i].active_calls) == 0)
 				TASK->phones[i].state = IPC_PHONE_FREE;
-				TASK->phones[i].callee = NULL;
-			}
 			
 			/* Just for sure, we might have had some 
@@ -607,4 +574,5 @@
 		ASSERT((call->flags & IPC_CALL_ANSWERED) ||
 		    (call->flags & IPC_CALL_NOTIF));
+		ASSERT(!(call->flags & IPC_CALL_STATIC_ALLOC));
 		
 		/*
@@ -625,6 +593,4 @@
 	ipc_call_slab = slab_cache_create("ipc_call", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	ipc_answerbox_slab = slab_cache_create("ipc_answerbox",
-	    sizeof(answerbox_t), 0, NULL, NULL, 0);
 }
 
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/ipc/irq.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -418,4 +418,5 @@
 		case CMD_ACCEPT:
 			return IRQ_ACCEPT;
+			break;
 		case CMD_DECLINE:
 		default:
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/ipc/sysipc.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -61,5 +61,5 @@
 { \
 	if (phoneid > IPC_MAX_PHONES) { \
-		err \
+		err; \
 	} \
 	phone = &TASK->phones[phoneid]; \
@@ -122,4 +122,5 @@
 	case IPC_M_DATA_READ:
 		return 1;
+		break;
 	default:
 		return 0;
@@ -375,5 +376,5 @@
 		phone_t *cloned_phone;
 		GET_CHECK_PHONE(cloned_phone, IPC_GET_ARG1(call->data),
-		    return ENOENT;);
+		    return ENOENT);
 		phones_lock(cloned_phone, phone);
 		if ((cloned_phone->state != IPC_PHONE_CONNECTED) ||
@@ -530,42 +531,39 @@
     unative_t arg1, unative_t arg2, unative_t arg3, ipc_data_t *data)
 {
-	call_t *call;
+	call_t call;
 	phone_t *phone;
 	int res;
 	int rc;
 	
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
-
-	call = ipc_call_alloc(0);
-	IPC_SET_METHOD(call->data, method);
-	IPC_SET_ARG1(call->data, arg1);
-	IPC_SET_ARG2(call->data, arg2);
-	IPC_SET_ARG3(call->data, arg3);
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
+
+	ipc_call_static_init(&call);
+	IPC_SET_METHOD(call.data, method);
+	IPC_SET_ARG1(call.data, arg1);
+	IPC_SET_ARG2(call.data, arg2);
+	IPC_SET_ARG3(call.data, arg3);
 	/*
 	 * To achieve deterministic behavior, zero out arguments that are beyond
 	 * the limits of the fast version.
 	 */
-	IPC_SET_ARG4(call->data, 0);
-	IPC_SET_ARG5(call->data, 0);
-
-	if (!(res = request_preprocess(call, phone))) {
+	IPC_SET_ARG4(call.data, 0);
+	IPC_SET_ARG5(call.data, 0);
+
+	if (!(res = request_preprocess(&call, phone))) {
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_begin();
 #endif
-		rc = ipc_call_sync(phone, call);
+		rc = ipc_call_sync(phone, &call);
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_end();
 #endif
-		if (rc != EOK) {
-			/* The call will be freed by ipc_cleanup(). */
+		if (rc != EOK)
 			return rc;
-		}
-		process_answer(call);
+		process_answer(&call);
 
 	} else {
-		IPC_SET_RETVAL(call->data, res);
-	}
-	rc = STRUCT_TO_USPACE(&data->args, &call->data.args);
-	ipc_call_free(call);
+		IPC_SET_RETVAL(call.data, res);
+	}
+	rc = STRUCT_TO_USPACE(&data->args, &call.data.args);
 	if (rc != 0)
 		return rc;
@@ -586,38 +584,32 @@
     ipc_data_t *reply)
 {
-	call_t *call;
+	call_t call;
 	phone_t *phone;
 	int res;
 	int rc;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
-
-	call = ipc_call_alloc(0);
-	rc = copy_from_uspace(&call->data.args, &question->args,
-	    sizeof(call->data.args));
-	if (rc != 0) {
-		ipc_call_free(call);
+	ipc_call_static_init(&call);
+	rc = copy_from_uspace(&call.data.args, &question->args,
+	    sizeof(call.data.args));
+	if (rc != 0)
 		return (unative_t) rc;
-	}
-
-
-	if (!(res = request_preprocess(call, phone))) {
+
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
+
+	if (!(res = request_preprocess(&call, phone))) {
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_begin();
 #endif
-		rc = ipc_call_sync(phone, call);
+		rc = ipc_call_sync(phone, &call);
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_end();
 #endif
-		if (rc != EOK) {
-			/* The call will be freed by ipc_cleanup(). */
+		if (rc != EOK)
 			return rc;
-		}
-		process_answer(call);
+		process_answer(&call);
 	} else 
-		IPC_SET_RETVAL(call->data, res);
-
-	rc = STRUCT_TO_USPACE(&reply->args, &call->data.args);
-	ipc_call_free(call);
+		IPC_SET_RETVAL(call.data, res);
+
+	rc = STRUCT_TO_USPACE(&reply->args, &call.data.args);
 	if (rc != 0)
 		return rc;
@@ -666,5 +658,5 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL);
 
 	call = ipc_call_alloc(0);
@@ -705,5 +697,5 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL);
 
 	call = ipc_call_alloc(0);
@@ -755,5 +747,5 @@
 	call->flags |= IPC_CALL_FORWARDED;
 
-	GET_CHECK_PHONE(phone, phoneid, {
+	GET_CHECK_PHONE(phone, phoneid, { 
 		IPC_SET_RETVAL(call->data, EFORWARD);
 		ipc_answer(&TASK->answerbox, call);
@@ -960,5 +952,5 @@
 	phone_t *phone;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
 
 	if (ipc_phone_hangup(phone))
@@ -999,4 +991,6 @@
 
 	if (call->flags & IPC_CALL_NOTIF) {
+		ASSERT(! (call->flags & IPC_CALL_STATIC_ALLOC));
+
 		/* Set in_phone_hash to the interrupt counter */
 		call->data.phone = (void *) call->priv;
@@ -1011,4 +1005,6 @@
 	if (call->flags & IPC_CALL_ANSWERED) {
 		process_answer(call);
+
+		ASSERT(! (call->flags & IPC_CALL_STATIC_ALLOC));
 
 		if (call->flags & IPC_CALL_DISCARD_ANSWER) {
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/lib/elf.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -163,4 +163,5 @@
 	case PT_LOAD:
 		return load_segment(entry, elf, as);
+		break;
 	case PT_DYNAMIC:
 	case PT_INTERP:
@@ -181,4 +182,5 @@
 	default:
 		return EE_UNSUPPORTED;
+		break;
 	}
 	return EE_OK;
Index: kernel/generic/src/lib/string.c
===================================================================
--- kernel/generic/src/lib/string.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/lib/string.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -537,5 +537,5 @@
  * null-terminated and containing only complete characters.
  *
- * @param dest   Destination buffer.
+ * @param dst   Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
@@ -571,5 +571,5 @@
  * have to be null-terminated.
  *
- * @param dest   Destination buffer.
+ * @param dst   Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
@@ -596,32 +596,36 @@
 }
 
-/** Convert wide string to string.
- *
- * Convert wide string @a src to string. The output is written to the buffer
- * specified by @a dest and @a size. @a size must be non-zero and the string
- * written will always be well-formed.
- *
- * @param dest	Destination buffer.
- * @param size	Size of the destination buffer.
- * @param src	Source wide string.
- */
-void wstr_to_str(char *dest, size_t size, const wchar_t *src)
-{
+/** Copy NULL-terminated wide string to string
+ *
+ * Copy source wide string @a src to destination buffer @a dst.
+ * No more than @a size bytes are written. NULL-terminator is always
+ * written after the last succesfully copied character (i.e. if the
+ * destination buffer is has at least 1 byte, it will be always
+ * NULL-terminated).
+ *
+ * @param src   Source wide string.
+ * @param dst   Destination buffer.
+ * @param count Size of the destination buffer.
+ *
+ */
+void wstr_nstr(char *dst, const wchar_t *src, size_t size)
+{
+	/* No space for the NULL-terminator in the buffer */
+	if (size == 0)
+		return;
+	
 	wchar_t ch;
-	size_t src_idx;
-	size_t dest_off;
-
-	/* There must be space for a null terminator in the buffer. */
-	ASSERT(size > 0);
-
-	src_idx = 0;
-	dest_off = 0;
+	size_t src_idx = 0;
+	size_t dst_off = 0;
 	
 	while ((ch = src[src_idx++]) != 0) {
-		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
+		if (chr_encode(ch, dst, &dst_off, size) != EOK)
 			break;
 	}
-
-	dest[dest_off] = '\0';
+	
+	if (dst_off >= size)
+		dst[size - 1] = 0;
+	else
+		dst[dst_off] = 0;
 }
 
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/mm/backend_phys.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -40,5 +40,4 @@
 #include <arch/types.h>
 #include <mm/as.h>
-#include <mm/page.h>
 #include <mm/frame.h>
 #include <mm/slab.h>
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/proc/task.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -54,5 +54,4 @@
 #include <func.h>
 #include <string.h>
-#include <memstr.h>
 #include <syscall/copy.h>
 #include <macros.h>
@@ -76,9 +75,6 @@
 static task_id_t task_counter = 0;
 
-static slab_cache_t *task_slab;
-
 /* Forward declarations. */
 static void task_kill_internal(task_t *);
-static int tsk_constructor(void *, int);
 
 /** Initialize kernel tasks support. */
@@ -87,6 +83,4 @@
 	TASK = NULL;
 	avltree_create(&tasks_tree);
-	task_slab = slab_cache_create("task_slab", sizeof(task_t), 0,
-	    tsk_constructor, NULL, 0);
 }
 
@@ -134,72 +128,65 @@
 }
 
-int tsk_constructor(void *obj, int kmflags)
-{
-	task_t *ta = obj;
+/** Create new task with no threads.
+ *
+ * @param as		Task's address space.
+ * @param name		Symbolic name (a copy is made).
+ *
+ * @return		New task's structure.
+ *
+ */
+task_t *task_create(as_t *as, char *name)
+{
+	ipl_t ipl;
+	task_t *ta;
 	int i;
+	
+	ta = (task_t *) malloc(sizeof(task_t), 0);
+
+	task_create_arch(ta);
+
+	spinlock_initialize(&ta->lock, "task_ta_lock");
+	list_initialize(&ta->th_head);
+	ta->as = as;
+
+	memcpy(ta->name, name, TASK_NAME_BUFLEN);
+	ta->name[TASK_NAME_BUFLEN - 1] = 0;
 
 	atomic_set(&ta->refcount, 0);
 	atomic_set(&ta->lifecount, 0);
-	atomic_set(&ta->active_calls, 0);
-
-	spinlock_initialize(&ta->lock, "task_ta_lock");
-	mutex_initialize(&ta->futexes_lock, MUTEX_PASSIVE);
-
-	list_initialize(&ta->th_head);
-	list_initialize(&ta->sync_box_head);
+	ta->context = CONTEXT;
+
+	ta->capabilities = 0;
+	ta->cycles = 0;
+
+#ifdef CONFIG_UDEBUG
+	/* Init debugging stuff */
+	udebug_task_init(&ta->udebug);
+
+	/* Init kbox stuff */
+	ipc_answerbox_init(&ta->kb.box, ta);
+	ta->kb.thread = NULL;
+	mutex_initialize(&ta->kb.cleanup_lock, MUTEX_PASSIVE);
+	ta->kb.finished = false;
+#endif
 
 	ipc_answerbox_init(&ta->answerbox, ta);
 	for (i = 0; i < IPC_MAX_PHONES; i++)
 		ipc_phone_init(&ta->phones[i]);
-
-#ifdef CONFIG_UDEBUG
-	/* Init kbox stuff */
-	ta->kb.thread = NULL;
-	ipc_answerbox_init(&ta->kb.box, ta);
-	mutex_initialize(&ta->kb.cleanup_lock, MUTEX_PASSIVE);
-#endif
-
-	return 0;
-}
-
-/** Create new task with no threads.
- *
- * @param as		Task's address space.
- * @param name		Symbolic name (a copy is made).
- *
- * @return		New task's structure.
- *
- */
-task_t *task_create(as_t *as, char *name)
-{
-	ipl_t ipl;
-	task_t *ta;
-	
-	ta = (task_t *) slab_alloc(task_slab, 0);
-	task_create_arch(ta);
-	ta->as = as;
-	memcpy(ta->name, name, TASK_NAME_BUFLEN);
-	ta->name[TASK_NAME_BUFLEN - 1] = 0;
-
-	ta->context = CONTEXT;
-	ta->capabilities = 0;
-	ta->cycles = 0;
-
-#ifdef CONFIG_UDEBUG
-	/* Init debugging stuff */
-	udebug_task_init(&ta->udebug);
-
-	/* Init kbox stuff */
-	ta->kb.finished = false;
-#endif
-
-	if ((ipc_phone_0) &&
-	    (context_check(ipc_phone_0->task->context, ta->context)))
+	if ((ipc_phone_0) && (context_check(ipc_phone_0->task->context,
+	    ta->context)))
 		ipc_phone_connect(&ta->phones[0], ipc_phone_0);
-
+	atomic_set(&ta->active_calls, 0);
+
+	mutex_initialize(&ta->futexes_lock, MUTEX_PASSIVE);
 	btree_create(&ta->futexes);
 	
 	ipl = interrupts_disable();
+
+	/*
+	 * Increment address space reference count.
+	 */
 	atomic_inc(&as->refcount);
+
 	spinlock_lock(&tasks_lock);
 	ta->taskid = ++task_counter;
@@ -242,5 +229,5 @@
 		as_destroy(t->as);
 	
-	slab_free(task_slab, t);
+	free(t);
 	TASK = NULL;
 }
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/proc/thread.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -501,12 +501,5 @@
 void thread_sleep(uint32_t sec)
 {
-	/* Sleep in 1000 second steps to support
-	   full argument range */
-	while (sec > 0) {
-		uint32_t period = (sec > 1000) ? 1000 : sec;
-	
-		thread_usleep(period * 1000000);
-		sec -= period;
-	}
+	thread_usleep(sec * 1000000);
 }
 
@@ -582,7 +575,7 @@
 {
 	waitq_t wq;
-	
+				  
 	waitq_initialize(&wq);
-	
+
 	(void) waitq_sleep_timeout(&wq, usec, SYNCH_FLAGS_NON_BLOCKING);
 }
@@ -819,11 +812,4 @@
 }
 
-/** Syscall wrapper for sleeping. */
-unative_t sys_thread_usleep(uint32_t usec)
-{
-	thread_usleep(usec);
-	return 0;
-}
-
 /** @}
  */
Index: kernel/generic/src/synch/futex.c
===================================================================
--- kernel/generic/src/synch/futex.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/synch/futex.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -90,5 +90,5 @@
 /** Initialize kernel futex structure.
  *
- * @param futex		Kernel futex structure.
+ * @param futex Kernel futex structure.
  */
 void futex_initialize(futex_t *futex)
@@ -102,11 +102,13 @@
 /** Sleep in futex wait queue.
  *
- * @param uaddr		Userspace address of the futex counter.
- *
- * @return		If there is no physical mapping for uaddr ENOENT is
- *			returned. Otherwise returns a wait result as defined in
- *			synch.h.
- */
-unative_t sys_futex_sleep(uintptr_t uaddr)
+ * @param uaddr Userspace address of the futex counter.
+ * @param usec If non-zero, number of microseconds this thread is willing to
+ *     sleep.
+ * @param flags Select mode of operation.
+ *
+ * @return One of ESYNCH_TIMEOUT, ESYNCH_OK_ATOMIC and ESYNCH_OK_BLOCKED. See
+ *     synch.h. If there is no physical mapping for uaddr ENOENT is returned.
+ */
+unative_t sys_futex_sleep_timeout(uintptr_t uaddr, uint32_t usec, int flags)
 {
 	futex_t *futex;
@@ -138,5 +140,7 @@
 	udebug_stoppable_begin();
 #endif
-	rc = waitq_sleep_timeout(&futex->wq, 0, SYNCH_FLAGS_INTERRUPTIBLE); 
+	rc = waitq_sleep_timeout(&futex->wq, usec, flags |
+	    SYNCH_FLAGS_INTERRUPTIBLE);
+
 #ifdef CONFIG_UDEBUG
 	udebug_stoppable_end();
@@ -147,7 +151,7 @@
 /** Wakeup one thread waiting in futex wait queue.
  *
- * @param uaddr		Userspace address of the futex counter.
- *
- * @return		ENOENT if there is no physical mapping for uaddr.
+ * @param uaddr Userspace address of the futex counter.
+ *
+ * @return ENOENT if there is no physical mapping for uaddr.
  */
 unative_t sys_futex_wakeup(uintptr_t uaddr)
@@ -186,7 +190,7 @@
  * If the structure does not exist already, a new one is created.
  *
- * @param paddr		Physical address of the userspace futex counter.
- *
- * @return		Address of the kernel futex structure.
+ * @param paddr Physical address of the userspace futex counter.
+ *
+ * @return Address of the kernel futex structure.
  */
 futex_t *futex_find(uintptr_t paddr)
@@ -280,8 +284,8 @@
 /** Compute hash index into futex hash table.
  *
- * @param key		Address where the key (i.e. physical address of futex
- *			counter) is stored.
- *
- * @return		Index into futex hash table.
+ * @param key Address where the key (i.e. physical address of futex counter) is
+ *     stored.
+ *
+ * @return Index into futex hash table.
  */
 size_t futex_ht_hash(unative_t *key)
@@ -292,8 +296,8 @@
 /** Compare futex hash table item with a key.
  *
- * @param key		Address where the key (i.e. physical address of futex
- *			counter) is stored.
- *
- * @return		True if the item matches the key. False otherwise.
+ * @param key Address where the key (i.e. physical address of futex counter) is
+ *     stored.
+ *
+ * @return True if the item matches the key. False otherwise.
  */
 bool futex_ht_compare(unative_t *key, size_t keys, link_t *item)
@@ -309,5 +313,5 @@
 /** Callback for removal items from futex hash table.
  *
- * @param item		Item removed from the hash table.
+ * @param item Item removed from the hash table.
  */
 void futex_ht_remove_callback(link_t *item)
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/syscall/syscall.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -111,5 +111,4 @@
 	(syshandler_t) sys_thread_exit,
 	(syshandler_t) sys_thread_get_id,
-	(syshandler_t) sys_thread_usleep,
 	
 	(syshandler_t) sys_task_get_id,
@@ -118,5 +117,5 @@
 	
 	/* Synchronization related syscalls. */
-	(syshandler_t) sys_futex_sleep,
+	(syshandler_t) sys_futex_sleep_timeout,
 	(syshandler_t) sys_futex_wakeup,
 	(syshandler_t) sys_smc_coherence,
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -50,5 +50,4 @@
 #include <udebug/udebug.h>
 #include <udebug/udebug_ops.h>
-#include <memstr.h>
 
 /**
Index: tools/config.py
===================================================================
--- tools/config.py	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ tools/config.py	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -227,8 +227,5 @@
 	
 	timestamp = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
-	
-	sys.stderr.write("Fetching current revision identifier ... ")
 	version = subprocess.Popen(['bzr', 'version-info', '--custom', '--template={clean}:{revno}:{revision_id}'], stdout = subprocess.PIPE).communicate()[0].split(':')
-	sys.stderr.write("OK\n")
 	
 	if (len(version) == 3):
